#!/usr/bin/python
# -*- coding: utf-8 -*-


import os
import random
import pyrrd.rrd
import pyrrd.graph
import xml
import xml.dom


class RRDTool(object):
  """
  """
  def __init__(self,out_dir='./'):
    self.start=None
    self.heartbeat=1
    self.xff=0.5
    self.steps=1
    self.rows=None
    self.out_dir=out_dir
    #self.filename=''
    #self.graphfile=''
    self.filename='users.rrd'
    self.graphfile='users.png'
    self.color={'r':random.randint(10, 99),'g':random.randint(10, 99),'b':random.randint(10, 99)}

  def AColor(self):
    """
    """
    for letr in self.color.keys():
      self.color[letr]+=random.randint(10, 30)
      if self.color[letr] >= 100:
	self.color[letr]+=-100
      if self.color[letr] < 10:
	self.color[letr]+=random.randint(10, 30)
    return '#'+str(self.color['r'])+str(self.color['g'])+str(self.color['b'])

  def SaveTimelines(self,timelines):
    """
    """
    self.dss=[]
    self.rras=[]
    self.start=timelines[timelines.keys()[0]].begining
    self.rows=timelines[timelines.keys()[0]].end-timelines[timelines.keys()[0]].begining
    for desc in timelines.keys():
      self.dss.append(pyrrd.rrd.DS(ds_name=desc, ds_type='ABSOLUTE', heartbeat=self.heartbeat))
    self.rras.append(pyrrd.rrd.RRA(cf='AVERAGE', xff=self.xff, steps=self.steps, rows=self.rows))
    self.rrd=pyrrd.rrd.RRD(self.out_dir+self.filename, ds=self.dss, rra=self.rras, start=self.start-1, step=1)
    self.rrd.create()
    
    for time_stamp in range(self.start,self.start+self.rows+1):
      param_tupl=()
      for desc in timelines.keys():
	param_tupl+=(timelines[desc].time[time_stamp],)
      self.rrd.bufferValue(time_stamp,*param_tupl)
      if time_stamp % 100 == 0:
	self.rrd.update()
    self.rrd.update()

  def GraphTimelines(self,timelines,tmp_rrd=False):
    """
    """
    if tmp_rrd:
      self.SaveTimelines(timelines)
    self.defs={}
    self.lines={}
    for desc in timelines.keys():
      self.defs[desc]=pyrrd.graph.DEF(rrdfile=self.out_dir+self.filename, vname='def'+desc, ds_name=desc, cdef='AVERAGE')
      self.lines[desc]=pyrrd.graph.LINE(width=1, def_obj=self.defs[desc], color=self.AColor(), legend=desc)
    tograph=[]
    for the_def in self.defs.keys():
      tograph.append(self.defs[the_def])
    for the_line in self.lines.keys():
      tograph.append(self.lines[the_line])
	
    g=pyrrd.graph.Graph(self.out_dir+self.graphfile, start=self.start, end=self.start+self.rows, vertical_label='bytes', imgformat='PNG', width=600, height=250)
    g.data.extend(tograph)
    g.write()
    
    if tmp_rrd:
      os.unlink(self.out_dir+self.filename)


class XHTML(object):
  def __init__(self,out_dir='./'):
    self.filename='index.xhtml'
    self.title=False
    self.grf_file_path=False
    self.user_data=False
    self.out_dir=out_dir
    
    self.dom_imp = xml.dom.getDOMImplementation()
    self.doctype = self.dom_imp.createDocumentType('html','-//W3C//DTD XHTML 1.0 Transitional//EN','http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd')
    self.doc = self.dom_imp.createDocument('http://www.w3.org/1999/xhtml','html',self.doctype)
    self.doc.documentElement.setAttribute('xmlns','http://www.w3.org/1999/xhtml')
  
  def SetData(self,title,grf_file,user_data):
    self.title=title
    self.grf_file_path=grf_file
    self.user_data=user_data
  
  def WriteFile(self):
    xhtml_file=open(self.out_dir+self.filename,'w')
    xhtml_file.write(self.xhtml())
    xhtml_file.close()
  
  def xhtml(self):
    head=self.doc.createElement('head')
    self.doc.documentElement.appendChild(head)
    title=self.doc.createElement('title')
    head.appendChild(title)
    title.appendChild(self.doc.createTextNode(self.title))
    
    meta=self.doc.createElement('meta')
    head.appendChild(meta)
    meta.setAttribute('HTTP-EQUIV','Refresh')
    meta=self.doc.createElement('meta')
    head.appendChild(meta)
    meta.setAttribute('CONTENT','300')
    
    meta=self.doc.createElement('meta')
    head.appendChild(meta)
    meta.setAttribute('HTTP-EQUIV','Cache-Control')
    meta=self.doc.createElement('meta')
    head.appendChild(meta)
    meta.setAttribute('CONTENT','no-cache')
    
    meta=self.doc.createElement('meta')
    head.appendChild(meta)
    meta.setAttribute('HTTP-EQUIV','Pragma')
    meta=self.doc.createElement('meta')
    head.appendChild(meta)
    meta.setAttribute('CONTENT','no-cache')
    
    body=self.doc.createElement('body')
    self.doc.documentElement.appendChild(body)
    title=self.doc.createElement('h1')
    body.appendChild(title)
    title.appendChild(self.doc.createTextNode(self.title))
    graph=self.doc.createElement('img')
    body.appendChild(graph)
    graph.setAttribute('src',self.grf_file_path)
    graph.setAttribute('alt',self.grf_file_path)
    
    table=self.doc.createElement('table')
    body.appendChild(table)
    tr=self.doc.createElement('tr')
    table.appendChild(tr)
    th=self.doc.createElement('th')
    tr.appendChild(th)
    th.appendChild(self.doc.createTextNode('Usuario'))
    th=self.doc.createElement('th')
    tr.appendChild(th)
    th.appendChild(self.doc.createTextNode('Tráfico'))
    
    for user in self.user_data.keys():
      tr=self.doc.createElement('tr')
      table.appendChild(tr)
      td=self.doc.createElement('td')
      tr.appendChild(td)
      td.appendChild(self.doc.createTextNode(user))
      td=self.doc.createElement('td')
      tr.appendChild(td)
      td.appendChild(self.doc.createTextNode(str(self.user_data[user])))
    
    
    return self.doc.toxml()